#include <GMLuaModule.h>

#include <interface.h>

#include <windows.h>
#include <detours.h>

#include "sigscan.h"

GMOD_MODULE(Open, Close);

ILuaInterface *gLua = NULL;

CSigScan UpdateLuaMD5_Sig;

typedef const char * (__cdecl *UpdateLuaMD5_t)(void *, int, int);

const char * (__cdecl *UpdateLuaMD5T)(void *, int, int) = NULL;

const char *UpdateLuaMD5D(void *unknown1, int unknown2, int unknown3)
{
	ILuaObject *hookT = gLua->GetGlobal("hook");
		gLua->Push(hookT->GetMember("Call"));

		gLua->Push("UpdateLuaMD5");
	
		gLua->Call(1, 1);
	hookT->UnReference();

	if (gLua->GetReturn(0)->isNil())
		return (UpdateLuaMD5T(unknown1, unknown2, unknown3));
	else
		return (gLua->GetReturn(0)->GetString());
}

int Open(lua_State *L)
{
	gLua = Lua();

	CreateInterfaceFn sharedFactory = Sys_GetFactory("lua_shared.dll");

	CSigScan::sigscan_dllfunc = (CreateInterfaceFn)sharedFactory(GMODLUASHAREDINTERFACE, NULL);
	CSigScan::GetDllMemInfo();

	UpdateLuaMD5_Sig.Init((unsigned char *)"\x8B\x44\x24\x08\x8B\x4C\x24\x04\x6A\x40\x68", "xxxxxxxxxxx", 11);

	if (UpdateLuaMD5_Sig.is_set)
	{
		UpdateLuaMD5T = (UpdateLuaMD5_t)UpdateLuaMD5_Sig.sig_addr;

		DetourTransactionBegin();
		DetourUpdateThread(GetCurrentThread());

		DetourAttach(&(PVOID &)UpdateLuaMD5T, (PVOID)(&(PVOID &)UpdateLuaMD5D));

		DetourTransactionCommit();
	}
	else
	{
		gLua->Msg("[UpdateLuaMD5] Signature scan failed\n");
	}

	return 0;
}

int Close(lua_State *L)
{
	if (UpdateLuaMD5_Sig.is_set)
	{
		DetourTransactionBegin();
		DetourUpdateThread(GetCurrentThread());

		DetourDetach(&(PVOID &)UpdateLuaMD5T, (PVOID)(&(PVOID &)UpdateLuaMD5D));

		DetourTransactionCommit();
	}

	return 0;
}